
var browserMgr = {
	_currentBrowser : null,
};

/** Initialisations */
browserMgr.init = function(pCurrentBrowser){
	this._currentBrowser = pCurrentBrowser;
		
	window.XULBrowserWindow = new nsBrowserStatusHandler();
 	window.QueryInterface(nsCI.nsIInterfaceRequestor)
        .getInterface(nsIWebNavigation)
        .QueryInterface(nsCI.nsIDocShellTreeItem).treeOwner
        .QueryInterface(nsCI.nsIInterfaceRequestor)
        .getInterface(nsCI.nsIXULWindow)
        .XULBrowserWindow = window.XULBrowserWindow;
}

/** Maj de l'tat des boutons prc?dent et suivant */
browserMgr.updateBackForwardButtons = function(){
  var backBroadcaster = document.getElementById("Browser:Back");
  var forwardBroadcaster = document.getElementById("Browser:Forward");
  var webNavigation = this._currentBrowser.webNavigation;
  var backDisabled = backBroadcaster.hasAttribute("disabled");
  var forwardDisabled = forwardBroadcaster.hasAttribute("disabled");
  if (backDisabled == webNavigation.canGoBack) {
    if (backDisabled)
      backBroadcaster.removeAttribute("disabled");
    else
      backBroadcaster.setAttribute("disabled", true);
  }
  if (forwardDisabled == webNavigation.canGoForward) {
    if (forwardDisabled)
      forwardBroadcaster.removeAttribute("disabled");
    else
      forwardBroadcaster.setAttribute("disabled", true);
  }
}

browserMgr.goBack = function(){
	this._currentBrowser.stop();
	this._currentBrowser.goBack();
}
browserMgr.goForward = function(){
	this._currentBrowser.stop();
	this._currentBrowser.goForward();
}
browserMgr.print = function(){
	try{
		PrintUtils.print();
	}catch(e){
		ut.debug("browserMgr > xPrint : " + e);
	}
}
browserMgr.printSetup = function(){
	PrintUtils.showPageSetup();
}
browserMgr.printPreview = function(){
	function onEnterPrintPreview(){
    	// On peut modifier la fen?tre xul ici.
	}
	function onExitPrintPreview(){
    	// On ferme la fenetre ici si elle ne sert que pour la pr?visualisation.
   	 	window.close();
  	}
	PrintUtils.printPreview(onEnterPrintPreview, onExitPrintPreview);
}




function nsBrowserStatusHandler(){}

nsBrowserStatusHandler.prototype = {
  // Stored Status, Link and Loading values
  status : "",
  defaultStatus : "",
  jsStatus : "",
  jsDefaultStatus : "",
  overLink : "",
  startTime : 0,
  statusText: "",
  lastURI: null,

  statusTimeoutInEffect : false,

  QueryInterface : function(aIID){
    if (aIID.equals(Components.interfaces.nsIWebProgressListener) ||
        aIID.equals(Components.interfaces.nsISupportsWeakReference) ||
        aIID.equals(Components.interfaces.nsIXULBrowserWindow) ||
        aIID.equals(Components.interfaces.nsISupports))
      return this;
    throw Components.results.NS_NOINTERFACE;
  },
  
  init : function(){},

  destroy : function(){},

  setJSStatus : function(status){
  	// Seule mthode appele au changement de page (li  la iFrame)
 	browserMgr.updateBackForwardButtons();
  },

  setJSDefaultStatus : function(status){},

  setDefaultStatus : function(status){ },

  setOverLink : function(link, b){},

  updateStatusField : function(){},

  onLinkIconAvailable : function(aBrowser){},

  onProgressChange : function (aWebProgress, aRequest,
                               aCurSelfProgress, aMaxSelfProgress,
                               aCurTotalProgress, aMaxTotalProgress){
	  if (this._requestsStarted == 1) {
	     var progress = document.getElementById("progress");
	     if (maxSelf == -1) {
	       progress.setAttribute("mode", "undetermined");
	     } else {
	       progress.setAttribute("mode", "determined");
	       progress.setAttribute("value", ((100 * curSelf) / maxSelf) + "%");
	     }
	   }
  },

  onStateChange : function(aWebProgress, aRequest, aStateFlags, aStatus){
 	const WPL = Components.interfaces.nsIWebProgressListener;

    var progress = document.getElementById("progress");

    if (stateFlags & WPL.STATE_IS_REQUEST) {
      if (stateFlags & WPL.STATE_START) {
        this._requestsStarted++;
      } else if (stateFlags & WPL.STATE_STOP) {
        this._requestsFinished++;
      }
      if (this._requestsStarted > 1) {
        var value = (100 * this._requestsFinished) /  this._requestsStarted;
        progress.setAttribute("mode", "determined");
        progress.setAttribute("value", value + "%");
      }
    }

   if (stateFlags & WPL.STATE_IS_NETWORK) {
     var stop = document.getElementById("stop");
     if (stateFlags & WPL.STATE_START) {
       stop.setAttribute("disabled", false);
       progress.setAttribute("style", "");
     } else if (stateFlags & WPL.STATE_STOP) {
       stop.setAttribute("disabled", true);
       progress.setAttribute("style", "display: none");
       this.onStatusChange(webProgress, request, 0, "Done");
       this._requestsStarted = this._requestsFinished = 0;
     }
   }
  },

  onLocationChange : function(aWebProgress, aRequest, aLocation){
   var urlbar = document.getElementById("urlbar");
   urlbar.value = location.spec;
   var browser = document.getElementById("content");
   var back = document.getElementById("Browser:Back");
   var forward = document.getElementById("Browser:Forward");
   back.setAttribute("disabled", !browser.canGoBack);
   forward.setAttribute("disabled", !browser.canGoForward);
  },

  onStatusChange : function(aWebProgress, aRequest, aStatus, aMessage){
	var status = document.getElementById("status");
   	status.setAttribute("label", message);
  },

  onSecurityChange : function(aWebProgress, aRequest, aState){
   const WPL = Components.interfaces.nsIWebProgressListener;
   var sec = document.getElementById("security");
   if (state & WPL.STATE_IS_INSECURE) {
     sec.setAttribute("style", "display: none");
   } else {
     var level = "unknown";
     if (state & WPL.STATE_IS_SECURE) {
       if (state & WPL.STATE_SECURE_HIGH)
         level = "high";
       else if (state & WPL.STATE_SECURE_MED)
         level = "medium";
       else if (state & WPL.STATE_SECURE_LOW)
         level = "low";
     } else if (state & WPL_STATE_IS_BROKEN) {
       level = "mixed";
     }
     sec.setAttribute("label", "Security: " + level);
     sec.setAttribute("style", "");
   }
  },

  startDocumentLoad : function(aRequest){},

  endDocumentLoad : function(aRequest, aStatus){}
}
